<template>
  <abeuni-form title="Cadastro" subtitle="Formulário de cadastro" @submit="submit">
    <form-section :number="1" title="Dados Pessoais">
      <!-- Personal data -->
      <label>
        Nome
        <input v-validate="{ required: true }" v-model="data.fullname" name="fullname" />
      </label>
      <label>
        Sexo
        <div>
          <input
            v-validate="{ required: true }"
            type="radio"
            value="male"
            v-model="data.sex"
            name="sex"
          />
          Masculino
          <input
            v-validate="{ required: true }"
            type="radio"
            value="female"
            v-model="data.sex"
            name="sex"
          />
          Feminino
        </div>
      </label>
      <label>
        Idade
        <input
          v-validate="{ required: true, numeric: true, min: 0, max: 150 }"
          v-model="data.age"
          name="age"
        />
      </label>

      <!-- Document type -->
      <label>
        Tipo de documento
        <div>
          <input
            type="radio"
            v-model="data.document.type"
            value="cpf"
            @click="data.document.value = ''"
          />
          CPF
          <input
            type="radio"
            v-model="data.document.type"
            value="rg"
            @click="data.document.value = ''"
          />
          RG
          <input
            type="radio"
            v-model="data.document.type"
            value="other"
            @click="data.document.value = ''"
          />
          Outros
        </div>
      </label>
      <label v-if="data.document.type === 'other'">
        Tipo do Documento
        <input v-model="data.document.other_type" />
      </label>
      <label>
        Documento
        <input
          v-if="!masks.brazil.documents[data.document.type]"
          v-model="data.document.value"
          name="document"
        />
        <the-mask
          v-else
          :mask="masks.brazil.documents[data.document.type] || ''"
          :masked="true"
          v-model="data.document.value"
        />
      </label>

      <label>
        Estado Civil
        <multiselect
          v-model="data.civil_status"
          :options="config.civil_status_options"
          placeholder="Select one"
          label="name"
          track-by="code"
        ></multiselect>
      </label>
    </form-section>

    <form-section :number="2" title="Endereço">
      <label>
        CEP
        <the-mask :mask="masks.brazil.address.CEP" v-model="data.address.CEP" />
      </label>
      <label>
        Logradouro
        <div class="autocomplete">
          <input
            type="text"
            v-model="data.address.street"
            @focus="streetFocused = true"
            @blur="streetFocused = false"
          />
          <div
            v-if="streetFocused && streetResults && streetResults.length > 0"
            class="autocomplete-results"
          >
            <div v-for="street in streetResults" :key="street.CEP" @mousedown="setStreet(street)">
              {{ street.street }}
              <span class="suburb">
                {{ street.suburb }} |
                {{ street.CEP.slice(0, 5) + "-" + street.CEP.slice(5) }}
              </span>
            </div>
          </div>
        </div>
      </label>
      <label>
        Número
        <input type="text" v-model="data.address.number" />
      </label>
      <label>
        Complemento
        <input type="text" v-model="data.address.complement" />
      </label>
    </form-section>

    <!-- Contact -->
    <form-section :number="3" title="Contato">
      <label>
        Telefone
        <the-mask
          :masked="true"
          :mask="['(##) ####-####', '(##) #####-####']"
          v-model="data.contact.phone_number"
        />
      </label>
      <label>
        Telefone de emergência
        <the-mask
          :masked="true"
          :mask="['(##) ####-####', '(##) #####-####']"
          v-model="data.contact.emergency_phone"
        />
      </label>
      <label>
        Contato de emergência
        <input type="text" v-model="data.contact.emergency_contact" />
      </label>
    </form-section>

    <!-- Divulgation -->
    <form-section :number="4" title="Divulgação">
      <label style="display: flex; flex-direction: column; align-items: flex-start;">
        Como ficou sabendo do evento da ABEUNI?
        <multiselect
          v-model="data.disclosure"
          tag-placeholder="Add this as new tag"
          placeholder="Search or add a tag"
          label="name"
          track-by="code"
          :options="config.disclosure_options"
          :multiple="true"
          :taggable="true"
        />
      </label>

      <label>
        Permite o uso de imagem?
        <div>
          <input type="radio" v-model="data.image_authorization" value="true" />
          Sim
          <input type="radio" v-model="data.image_authorization" value="false" />
          Não
        </div>
      </label>
    </form-section>

    <!-- QR code -->
    <form-section :number="5" title="QR Code">
      <the-mask mask="####-#" v-model="qr_code" />
    </form-section>

    <div class="button-cookie">
      <input type="submit" value="Registrar" />
    </div>
  </abeuni-form>
</template>

<script>
import uuid from 'uuid/v1'
import masks from './util/masks'
import AbeuniForm from './forms/AbeuniForm'
import FormSection from './forms/FormSection'
import { mapMutations, mapGetters } from 'vuex'
import fuzzysort from 'fuzzysort'
import _ from 'lodash'

export default {
  components: { AbeuniForm, FormSection },
  data () {
    return {
      masks,
      streetResults: null,
      streetFocused: false,
      config: {
        civil_status_options: [
          { name: 'Solteiro (a)', code: 'single' },
          { name: 'Casado (a)', code: 'married' },
          { name: 'União Estável', code: 'stable_union' },
          { name: 'Separado (a)', code: 'separated' },
          { name: 'Divorciado (a)', code: 'divorced' },
          { name: 'Viúvo (a)', code: 'widowed' }
        ],
        disclosure_options: [
          { name: 'Cartaz', code: 'cartaz' },
          { name: 'Panfleto recebido na rua', code: 'panfleto_rua' },
          { name: 'Panfleto recebido em casa', code: 'panfleto_casa' },
          { name: 'Facebook', code: 'facebook' },
          { name: 'Instagram', code: 'instagram' },
          { name: 'Whatsapp', code: 'whatsapp' },
          {
            name: 'Indicação por Conhecidos (verbal)',
            code: 'conhecidos_verbal'
          },
          { name: 'Divulgação no CEU', code: 'abeuni' },
          { name: 'Outros', code: 'outros' }
        ],
        template: {
          source: 'triagem',
          id: null,
          fullname: '',
          sex: '',
          age: '',
          contact: {
            phone_number: '',
            emergency_phone: '',
            emergency_contact: ''
          },
          address: {
            street: '',
            CEP: '',
            complement: '',
            number: ''
          },
          document: { type: 'cpf', value: '' }
        }
      },
      data: null,

      qr_code: null
    }
  },
  computed: {
    streetInput () {
      return this.data && this.data.address && this.data.address.street
    },
    cepInput () {
      return this.data && this.data.address && this.data.address.CEP
    },
    ...mapGetters(['streetList'])
  },
  watch: {
    streetInput: _.debounce(async function () {
      this.streetResults = (await fuzzysort.goAsync(
        this.streetInput.normalize('NFD').replace(/[\u0300-\u036f]/g, ''),
        this.streetList,
        {
          key: 'searchPrep',
          limit: 10,
          threshold: -10000
        }
      )).map(result => result.obj)
    }, 300),
    cepInput: _.debounce(async function () {
      const CEP = this.cepInput && this.cepInput.replace(/[^0-9]/g, '')
      if (CEP && CEP.length === 8 && this.streetList) {
        const street = this.streetList.find(item => item.CEP === CEP)
        this.data.address.street = (street && street.street) || ''
      }
    }, 100)
  },
  beforeMount () {
    this.resetFormulary()
  },
  mounted () {
    this.$store.dispatch('loadCEP')
  },
  methods: {
    ...mapMutations(['registerPerson', 'assignCode']),
    async submit () {
      if (!(await this.$validator.validateAll())) return

      if (!this.qr_code || !this.verifyCode(this.qr_code)) {
        alert('Invalid code!')
        return
      }

      try {
        this.data.timestamp = new Date()
        await this.registerPerson(this.data)
        await this.assignCode({
          code: this.qr_code,
          ref: this.data.id,
          id: uuid()
        })

        this.resetFormulary()
        alert(`${this.data.fullname} registered successfuly!`)
      } catch (e) {
        alert('Failed registering!')
        console.error(e)
      }
    },
    resetFormulary () {
      this.data = _.cloneDeep(this.config.template)
      this.data.id = uuid()
      this.qr_code = ''
    },
    setStreet (street) {
      console.log(street)
      this.data.address.street = street.street
      this.data.address.CEP = street.CEP
    },
    verifyCode (code) {
      const digits = code
        .slice(0, code.length - 1)
        .split('')
        .map(dig => parseInt(dig))
      const vdigit = parseInt(code.slice(code.length - 1))

      const expected =
        digits
          .map((dig, index) => Math.pow((index + 1) * dig, 3))
          .reduce((a, b) => a + b) % 10

      return vdigit === expected
    }
  }
}
</script>

<style lang="scss" scoped>
input.invalid {
  border-color: red;
}

.autocomplete {
  > .autocomplete-results {
    > * {
      .suburb {
        font-size: 0.8em;
      }

      display: flex;
      flex-direction: column;

      padding: 1em;

      cursor: pointer;

      background-color: white;
      transition-duration: 300ms;
    }

    > *:hover {
      background-color: lightgray;
    }

    position: absolute;
    top: 34px;
    z-index: 9999;

    width: 100%;

    display: flex;
    flex-direction: column;

    border: solid lightgray 1px;
  }

  position: relative;

  width: 100%;

  display: flex;
  flex-direction: column;
}
</style>
